import java.util.List;
import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Owl here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Owl extends Mover
{
    private int animateCounter;
    private int treeTimer;
    private GreenfootImage image0;
    private GreenfootImage image1;
    private GreenfootImage image2;
    private Squirrel target;
    private int interest;
    /**
     * Act - do whatever the Lizard wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public Owl()
    {
        image0 = new GreenfootImage("owl head.png");
        image1 = new GreenfootImage("owl1.png");
        image2 = new GreenfootImage("owl2.png");        
        setImage(image0);
        treeTimer = 50;
        interest = 200;
    }

    public void act() 
    {
        if (interest > 0)
        {
            faceTarget();
        }
        if (treeTimer > 0)
        {
            treeTimer--;
        }
        else
        {
            animate();
            move();
            interest--;
            lookForSquirrel();
        }
        if (atWorldEdge())
        {
            getWorld().removeObject(this);
        }
    }    

    /**
     * Makes a random turn.
     */
    public void randomTurn()
    {
        int randNum = Greenfoot.getRandomNumber(100);
        if (Greenfoot.getRandomNumber(100) < 10) {
            turn(Greenfoot.getRandomNumber(90) - 45);
        }
    }

    public void animate()
    {
        animateCounter++;
        if (animateCounter == 4)
        {
            setImage(image2);
        }
        if (animateCounter == 8)
        {
            setImage(image1);
            animateCounter =  0;
        }
    }

    public void faceTarget()  
    {  
        if(target == null)  
        {  
            if(!getWorld().getObjects(Squirrel.class).isEmpty())  
            {  
                target = (Squirrel) getWorld().getObjects(Squirrel.class).get(0);  
            }  
        }  
        if(target != null)  
        {  
            int xDiff = target.getX() - getX(),  
            yDiff = target.getY() - getY();  
            double angle = Math.toDegrees(Math.atan2(yDiff, xDiff));  
            setRotation((int)Math.round(angle));  
        }  
    }  
}
